import { defineNuxtPlugin } from "#app";
import NuxtLink from "#app/components/nuxt-link";
import { createPrismic } from "@prismicio/vue";
import client from "#build/prismic/proxy/client";
import linkResolver from "#build/prismic/proxy/linkResolver";
import htmlSerializer from "#build/prismic/proxy/htmlSerializer";
const pkgName = "@nuxtjs/prismic";
export default defineNuxtPlugin((nuxtApp) => {
  const mergedOptions = nuxtApp.payload.config[pkgName] ?? nuxtApp.payload.config.public[pkgName] ?? {};
  nuxtApp.vueApp.use(createPrismic({
    ...mergedOptions,
    client,
    linkResolver,
    htmlSerializer,
    injectComponents: false,
    components: {
      linkInternalComponent: NuxtLink,
      linkExternalComponent: NuxtLink,
      ...mergedOptions.components
    }
  }));
});
